/***************************************************************************
                          gifblocks.h  -  description
                             -------------------
    begin                : Thu Jun 15 2000
    copyright            : (C) 2000 by Helmut Fahrion
    email                : hefa@bitctrl.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef GIFBLOCKSINC

#else

#define MAKE_PRINTABLE(c)  (isprint(c) ? (c) : ' ')

// war halt fr C gedacht
extern "C"
{
#include <gif_lib.h>
}


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <fcntl.h>

#include <iostream.h>
#include <string.h>

#include <qpainter.h>
#include <qmessagebox.h>
#include <qpixmap.h>


    /*
       Allgemeine Listenklasse
     */

class liste
{
public:
  //liste(void);
  liste (liste * l);
  ~liste ();

  liste *getnext ()
  {
    return next;
  };
  liste *getprev ()
  {
    return prev;
  };

private:
    liste * next, *prev;
};


/* Allgemeine Klasse fr Gif-Blcke */
class gifblock:public liste
{
public:
  gifblock (gifblock * l);
  virtual ~ gifblock ();

  virtual void draw (void *widget, void *win) = 0;	// Zeichenfunktion  
  virtual unsigned int getnr () = 0;	// Zeichenfunktion
};



class color
{
public:
  color ()
  {
  };
  ~color ()
  {
  };

  unsigned char r, g, b;
};

class pixel
{
public:
  pixel ()
  {
  };
  ~pixel ()
  {
  };

  unsigned char p;
};


class colormap
{
public:
  colormap (ColorMapObject * cm);
  ~colormap ();

  color getcolor (pixel x)
  {
    return c[x.p];
  }
  color getcolor (unsigned char x)
  {
    return c[x];
  }
  int getlen ()
  {
    return len;
  }

  friend ostream & operator << (ostream & os, colormap * cm)
  {
    int i, j;
    if (cm)
      {
	os << "Global Color Map Len: " << cm->
	  len << " Bpl: " << cm->bpl << "\n";
	for (i = 0; i < cm->len; i += 4)
	  {
	    for (j = 0; j < 4 && j < cm->len; j++)
	      {
		os.form ("%3d: ", i + j);
		os.form ("%02xh ", cm->c[i + j].r);
		os.form ("%02xh ", cm->c[i + j].g);
		os.form ("%02xh ", cm->c[i + j].b);
	      }
	    os << "\n";
	  }
      }

    return os;
  }

protected:
private:
  int len, bpl;
  color *c;
};


// Gif Datei Screenblock
class screenblock:public gifblock
{
public:
  screenblock (gifblock * l, char *dateiname, int screenh, int screenw,
	       int screenc, int screenb, ColorMapObject * screencm);

    virtual ~ screenblock ();

  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer

  friend ostream & operator << (ostream & os, screenblock * sb)
  {
    os << "Dateiname: " << sb->dname << "\n"
      << "Screen Width: " << sb->sw << "\n"
      << "Screen Hight: " << sb->sh << "\n"
      << "Screen ColorResolution: " << sb->scr << "\n"
      << "Screen Backgroundcolor: " << sb->sbc << "\n"
      << "Screen Colormap?: " << (sb->cmap ? "Ja" : "Nein") << "\n";

    if (sb->cmap)
      os << sb->cmap;

    return os;
  }

  colormap *cmap;
  int sbc;

private:
  char dname[80];
  int sw, sh, scr, verb;
};

class graphicsblock:public gifblock
{
public:
  graphicsblock (gifblock * block, unsigned int nt, GifByteType * ext);
   ~graphicsblock ();

  friend ostream & operator << (ostream & os, graphicsblock * sb)
  {
    os << "GifGraphicsControl: " << "\n";

    os.form
      ("Block Size: %d,  Disposal Method: %d, User Input Flag: %d,\nTransparent Color: %u, Delay Time: %u (1/100) sek,\nTransparent Color Index: %u\n",
       sb->bs, sb->dm, sb->ui, sb->tc, (unsigned int) sb->dt, sb->tci);

    return os;
  }

  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer

  unsigned char dm, ui, tc, tci;
  unsigned int dt;

protected:
private:
  typedef struct grblock
  {
    char bs, pf;
    char dt1, dt2;
    char tc;
  }
  gb;
  gb *grbl;

  char bs;
};


class imagedesc:public gifblock
{
public:
  imagedesc (int wi, int hi):gifblock (NULL)
  {
    l = t = 0;
    w = wi;
    h = hi;
    (int) verb = (void *) cmap = (void *) pix = (void *) qpa =
      (void *) scrblk = (void *) prev = (void *) gcontrol = NULL;
  };

  imagedesc (gifblock * block, gifblock * sb, gifblock * pimg,
	     gifblock * gctrl, char verbose, GifFileType * GifFile);	// GifImageDesc img, int imgcnt);
  virtual ~ imagedesc ();

  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer


  friend ostream & operator << (ostream & os, imagedesc * sb)
  {
    os.form
      ("\nImage #%d:\n\n\tSize: Left = %d, Top = %d, Width = %d, Height = %d.\n",
       sb->n, sb->l, sb->t, sb->w, sb->h);
    os.form ("\tImage is %s", sb->i ? "Interlaced\n" : "Non Interlaced\n");

    os << "Image Nr: " << sb->n << "\n";

    if (sb->cmap)
      os << sb->cmap;

    return os;
  }

  void printpixelblock ();	// ASCIIausgabe

  // *** User berladefunktion 
  void userinput (char verbose);	// Userinputfunction, kann belibig berladen werden, default wartet 1s
  // *** User berladefunktion 
  void userbg (void *wdg, unsigned char mode);	// Zeichnet Hintergrund fr Transparente Images


protected:
private:
  void drawline (int y, int n, unsigned char tf, unsigned char ti,
		 void *widget);


  int l, t, w, h,		/* Current image dimensions. */
    i, n;			/* Sequential/Interlaced lines. */

  char verb;			// Verbose Mode

  colormap *cmap;		// Farbtabelle
  pixel *pix;			// Array of Pixels

  imagedesc *prev;		// Vorheriges Image
  screenblock *scrblk;		// zwecks Zugriff auf Screenblock
  graphicsblock *gcontrol;	// Zugriff auf Graphics Control

  QBrush qbr;
  QPointArray *qpa;		// Optimierung
};


class commentblock:public gifblock
{
public:
  commentblock (gifblock * block, GifByteType * ext);
  ~commentblock ();

  friend ostream & operator << (ostream & os, commentblock * sb)
  {
    return os << "GifCommentblock: len = " << sb->
      len << "\nStr: " << sb->str << "\n";
  }
  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer

protected:
private:
  int len;
  char *str;
};

// ##### Plaintext 
class ptextblock:public gifblock
{
public:
  // ptextblock () { str=NULL; };
  ptextblock (gifblock * block, gifblock * scrblock, GifByteType * ext);
  ~ptextblock ();

  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer

  friend ostream & operator << (ostream & os, ptextblock * sb)
  {
    os << "Plaintextblock Beschreibung: " << "\n";

    //os << "Block Size = " << sb->bs << "\n";
    return os.form
      ("Block Size = %d\nText Grid Left Position = %d\nText Grid Top Position = %d\nText Grid Width  = %d\nText Grid Height = %d\nCharacter Cell Width = %d\nCharacter Cell Height = %d\nText Foreground Color Index = %d\nText Background Color Index = %d\n",
       sb->bs, sb->tglp, sb->tgtp, sb->tgw, sb->tgh, sb->ccw, sb->cch, sb->fg,
       sb->bg);

  }

  unsigned int tglp,		// Text Grid Left Position 
    tgtp,			// Text Grid Top Position 
    tgw,			// Text Grid Width
    tgh;			// Text Grid Height
  unsigned char ccw,		// Character Cell Width
    cch,			// Character Cell Height
    fg,				// Text Foreground Color Index
    bg;				// Text Background Color Index

  color fgc, bgc;		// Ganze Farbe aus globaler Farbtabelle

protected:

private:
  typedef struct plaintextblock
  {
    char bs;			// Block Size    
    char tglp1, tglp2;		// Text Grid Left Position 
    char tgtp1, tgtp2;		// Text Grid Top Position
    char tgw1, tgw2;		// Text Grid Width
    char tgh1, tgh2;		// Text Grid Height
    char ccw,			// Character Cell Width
      cch,			// Character Cell Height
      fg,			// Text Foreground Color Index
      bg;			// Text Background Color Index
  }
  plaintb;

  plaintb *txtblk;
  //screenblock *scrblk;                // zwecks Zugriff auf Screenblock

  char bs;			// Block Size    
};

// ##### Plaintext String
class pstrblock:public gifblock
{
public:
  // ptextblock () { str=NULL; };
  pstrblock (gifblock * block, gifblock * beschblk, GifByteType * ext);
  ~pstrblock ();

  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer

  friend ostream & operator << (ostream & os, pstrblock * sb)
  {
    os << "Plain String Block: " << "\n";

    if (sb->ptstr)
      return os << "Text:\"" << sb->ptstr << "\"\n";
    else
      return os << "Text:\"" << "\"\n\n";
  }


protected:

private:
  typedef struct plaintextblock
  {
    char bs;			// Block Size    
    char tglp1, tglp2;		// Text Grid Left Position 
    char tgtp1, tgtp2;		// Text Grid Top Position
    char tgw1, tgw2;		// Text Grid Width
    char tgh1, tgh2;		// Text Grid Height
    char ccw,			// Character Cell Width
      cch,			// Character Cell Height
      fg,			// Text Foreground Color Index
      bg;			// Text Background Color Index
  }
  plaintb;

  plaintb *txtblk;

  ptextblock *bblk;

  char bs;			// Block Size    
  char *ptstr;
  QBrush qbr;
};


// **** Application Block  ******
class appblock:public gifblock
{
public:
  // ptextblock () { str=NULL; };
  appblock (gifblock * block, GifByteType * ext);
  ~appblock ();

  virtual void draw (void *widget, void *win);	// Zeichenfunktion
  virtual unsigned int getnr ();	// Imagenummer

  friend ostream & operator << (ostream & os, appblock * sb)
  {
    os << "Applicationblock: " << "\n";

    if (sb->anzahl)
      os.form ("Block Size= %d, Kennung=%d (Netscape Loop)), Anz=%u .\n",
	       sb->bs, sb->len, sb->anzahl);
    else
      os.form ("Block Size= %d, Indentifier=\"%s\", Auth Code \"%c%c%c\" .\n",
	       sb->bs, sb->str, MAKE_PRINTABLE (sb->a1),
	       MAKE_PRINTABLE (sb->a2), MAKE_PRINTABLE (sb->a3));

    return os;
  }

  int isloop ()
  {
    return anzahl;
  }

protected:

private:

  typedef struct applicationblock
  {
    char bs,			// Block Size    
      indent[8],		// Identifier
      a1, a2, a3;		// Application Auth Code
  }
  appbl;

  typedef struct applicationloop
  {
    char bs,			// Block Size    
      kennung;			// Identifier
    // warum short ? nicht 2x char !  
    short anz;			// Application Auth Code
  }
  loopblock;

  int anzahl;			// Loop

  unsigned char bs, len, a1, a2, a3;
  char str[10];

};

#endif
